/*  Bondgraph Modeling System, version 1.0, 11 Jan 2001
 *  Copyright (C) 2001  Michigan State University
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of version 2 of the GNU General Public License as
 *  published by the Free Software Foundation.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *  
 *  Jianjun Hu            (hujianju@msu.edu)
 *  
 *  Computer Science Department
 *  EB 2340 GARAGe Group
 *  Michigan State University
 *  East Lansing, Michigan  48824
 *  USA
 *  
 */

// Element2Port.h: interface for the CElement2Port class.

//

// Developed by Jianjun Hu 

// GARAGE Group, Michigan State University

////////////////////////////////////////////////////////////////////////



#if !defined(AFX_Element2Port_H__042E35AC_A770_11D4_BB82_00105A06D5B4__INCLUDED_)

#define AFX_Element2Port_H__042E35AC_A770_11D4_BB82_00105A06D5B4__INCLUDED_



#if _MSC_VER > 1000

#pragma once

#endif // _MSC_VER > 1000



#include "Port.h"
#include "Component.h"
#include <iostream>

//limits of Transformers and Gyrates
const double TRANSFORMER_MAX = 1000.0;
const double TRANSFORMER_MIN = 0.001;
const double      GYRATE_MAX = 1000.0;
const double      GYRATE_MIN = 0.001;

//Two port Element2Ports including GY, TF, Bond

class CElement2Port : public CComponent  

{

public:
	void Reset();
	virtual int SetPowerDirect(int direction, CPort* pPort=NULL);

	//CPort m_Port[2];// two ports 

	CElement2Port();
	void operator =(CElement2Port &el);

	virtual ~CElement2Port();

	virtual void read(std::istream& ioIS);
	virtual void write(std::ostream& ioOS) const;


};



#endif // !defined(AFX_Element2Port_H__042E35AC_A770_11D4_BB82_00105A06D5B4__INCLUDED_)

